#include <iostream>
#include <string.h> // old c string functions
#include <string>   // new C++ string class
#include "patient3.h"

using namespace std;
//using namespace AG;

CPatient::CPatient(const char *n, int a, char g)	// Normal constructor
{
	cout << "constructing patient" << endl;
	name_ptr = new char[strlen(n) +1];
	strcpy(name_ptr,n);
	age = a;
	gender = g;
}

CPatient::CPatient()  			//default constructor  no arguments
{
	cout << "default constructor" << endl;
	name_ptr = new char[strlen("A.N.Other") +1];
	strcpy(name_ptr,"A.N.Other");
	age = 0;
	gender = 'M';
}

CPatient::~CPatient()  			//destructor
{ 	
	cout << "default destructor" << endl;
	delete []name_ptr;
};

CPatient::CPatient(const CPatient& x)
{
	cout << "copy constructor" << endl;
	name_ptr = new char[strlen(x.name_ptr) +1];
	strcpy(name_ptr,x.name_ptr);
	age = x.age;
	gender = x.gender;
}

const CPatient& CPatient::operator=(const CPatient& x)  			
{
	if(this != &x)
	{
		delete []name_ptr; //release memory
		name_ptr = new char[strlen(x.name_ptr) +1];	//allocate memory for new name
		strcpy(name_ptr,x.name_ptr);
		age = x.age;
		gender = x.gender;
	}
	return (*this); //return invoking instance 
}

void CPatient::identify()
{
	cout << "name :" << name_ptr << endl;
	cout << "Age : " << age << endl;
	cout << "Gender :" << gender << endl;
}


void CPatient::set_name(char * n)
{
	delete []name_ptr;
	name_ptr = new char[strlen(n) +1];
	strcpy(name_ptr,n);
}

void CPatient::set_age(int a) 
{ 
	age = a; 
}

void CPatient::set_gender(char g) 
{
 	gender = g; 
}


const char * CPatient::get_name()
{
	return name_ptr;
}

int CPatient:: get_age() 
{ 
	return age; 
}

char CPatient::get_gender() 
{
 	return gender; 
}


//Private member function to produce title
string CPatient::get_title() const
{
	string temp = "Mr.";
	
	if (gender == 'F')
	{
		if (age < 16)
		{
			temp = "Miss";
		}
		else
		{
			temp = "Ms.";
		}
	}
	else
	{
		if (age < 16)
		{
			temp = "Master";
		}
	}
	return temp;
}


ostream & operator<<(ostream & os, const CPatient & p)
{
	string title = p.get_title();

	os << "=============================" << endl;
	os << "Name: " << title << " " << p.name_ptr << endl;
	os << "Age : " << p.age << endl;
	os << "Gender : " << p.gender << endl;
	os << "=============================" << endl;
	return os;
}





